package chapter39;

import java.util.*;

class Romans {
  private int number;

  //Define the getter
  public int getNumber() {
    return this.number;
  }
  //Define the setter
  public void setNumber(int value) throws Exception {
    if (value >= 1 && value <= 5) {
      this.number = value;
    }
    else {
      throw new Exception("Number not recognized");
    }
  }

  //Define the getter
  public String getRoman() {
    HashMap<Integer, String> number2roman = new HashMap<>(
      Map.of(1, "I", 2, "II", 3, "III", 4, "IV", 5, "V")
    );
    return number2roman.get(this.number);
  }
  //Define the setter
  public void setRoman(String key) throws Exception {
    HashMap<String, Integer> roman2number = new HashMap<>(
      Map.of("I", 1, "II", 2, "III", 3, "IV", 4, "V", 5)
    );
    if (roman2number.containsKey(key)) {
      this.number = roman2number.get(key);
    }
    else {
      throw new Exception("Roman numeral not recognized");
    }
  }
}

public class Class_39_5_1 {
  public static void main(String[] args) throws Exception {
    Romans x = new Romans();

    x.setNumber(3);
    System.out.println(x.getNumber());  //It displays: 3
    System.out.println(x.getRoman());   //It displays: III

    x.setRoman("V");
    System.out.println(x.getNumber());  //It displays: 5
    System.out.println(x.getRoman());   //It displays: V
  }
}
